	/* The default scroll bar colors */
#define SCROLL_BACK_COLOR CYAN
#define SCROLL_TEXT_COLOR BLACK

	/* The value for no mouse click */
#define NO_SCROLL -32002

	/* The text characters */
#define   SCROLL_UP_ARROW 24
#define SCROLL_DOWN_ARROW 25
#define     SCROLL_BUTTON 32
#define      SCROLL_SPACE 177


/*========== Class SCROLL_TYPE Definition =================================*/
class SCROLL_TYPE {

public:
  char x, y, y50;	/* Upper right coordinates of scroll bar */
  char length;	/* Length of scroll bar */
  char text_color, back_color;	/* Color of the bar */
  int min, value, max;	/* Value of the scroll bar */
  boolean visible;	/* Is the bar currently visible? */
  boolean pressed;	/* Is the button currently being pressed? */

	/* Class Constructor */
  SCROLL_TYPE(void);
  SCROLL_TYPE(const char x1, const char y1, const char y501, const char l,
	      const int minimum, const int maximum,
	      const char bcolor = SCROLL_BACK_COLOR, const char tcolor = SCROLL_TEXT_COLOR);


	/* Changes the maximum value */
  void change_max (const int how_much);

	/* Changes the Minimum Value */
  void change_min (const int how_much);

	/* Changes the Value */
  void change_value (int new_value);

	/* Checks to see if a Mouse was clicked on it */
  int check (const int mx, const int my, const int event);

	/* Draws the scroll bar */
  void draw(void);

	/* Resets the Scroll Bar to Contain Nothing */
  void reset (void);

	/* Updates the button position */
  void update_button (void);

};
/*========== End Class SCROLL_TYPE Definition =============================*/

